//########################
//IllustratorCS3で現在開いているドキュメントをEPSで
//指定されたバージョンで次々に保存していきます。そして閉じていきます。
//たけうちとおる
//########################

main();

function main(){
	var myAns = mydialog();
	var folderobj = getfolder();
	if(! folderobj){
		return;
	}
	var folderpath = folderobj.fsName + "/";
	saveFile(folderpath,myAns);
}
//alert(myAns['saveType']);
function mydialog(){
	//X1,Y1,X2,Y2
	var myDialog = new Window("dialog", "保存", [0,0,350,400]);
	myDialog.add("statictext",[5,5,340,20],"開いているドキュメントを全て保存します。");
	myDialog.add("statictext",[5,25,80,45],"バージョン");
	myDialog.ver_sel = myDialog.add("dropdownlist",[80,25,230,45],["Illustrator 8 EPS","Illustrator 9 EPS","Illustrator 10 EPS","Illustrator CS EPS","Illustrator CS2 EPS","Illustrator CS3 EPS","Illustrator CS4 EPS","Illustrator CS5 EPS"]);
	myDialog.ver_sel.selection=0;
	//プレビュー
	myDialog.f1 = myDialog.add("panel",[5,45,340,105],"プレビュー");	
	myDialog.f1.add("statictext",[5,10,35,30],"形式：");
	myDialog.prev_sel = myDialog.f1.add("dropdownlist",[50,10,200,30],["なし","TIFF (白黒)","TIFF (8-bit カラー)","Macintosh (白黒)","Macintosh (8-bit カラー)"]);
	myDialog.prev_sel.selection=2;
	myDialog.prev_r1 = myDialog.f1.add("radiobutton",[50,30,100,50],"透明");
	myDialog.prev_r2 = myDialog.f1.add("radiobutton",[100,30,200,50],"不透明");
	myDialog.prev_r1.value = true;
	//透明
	myDialog.f2 = myDialog.add("panel",[5,115,340,160],"透明");
	myDialog.f2.add("statictext",[5,10,100,30],"オーバープリント：");
	myDialog.overprint_sel = myDialog.f2.add("dropdownlist",[100,10,200,30],["保持","破棄"]);
	myDialog.overprint_sel.selection=0;
	//フォント
	myDialog.f3 = myDialog.add("panel",[5,170,340,210],"フォント");
	myDialog.font = myDialog.f3.add("checkbox",[5,5,280,25],"他のアプリケーション用にフォントを埋め込む");
	myDialog.font.value = true;
	//オプション
	myDialog.f4 = myDialog.add("panel",[5,220,340,370],"オプション");
	myDialog.opt01 = myDialog.f4.add("checkbox",[5,5,280,25],"配置した画像を含む");
	myDialog.opt02 = myDialog.f4.add("checkbox",[5,25,280,50],"サムネールを作成");
	myDialog.opt03 = myDialog.f4.add("checkbox",[5,50,280,75],"CMYK PostScriptをRGBファイルに含む");
	myDialog.opt04 = myDialog.f4.add("checkbox",[5,75,330,100],"コンパチブルグラデーション&グラデーションメッシュプリント");
	myDialog.opt01.value = false;
	myDialog.opt02.value = true;
	myDialog.opt03.value = true;
	myDialog.opt04.value = false;
	myDialog.f4.add("statictext",[5,110,110,135],"Adobe PostScript：");
	myDialog.opt_sel = myDialog.f4.add("dropdownlist",[120,110,200,135],["レベル 2","レベル 3"]);
	myDialog.opt_sel.selection=0;
	//myDialog.ngBtn = myDialog.add("button",[10,380,100,400],"キャンセル", { name:"cancel"});
	myDialog.okBtn = myDialog.add("button",[150,375,200,390],"実行", { name:"ok"});
	myDialog.center();
	myDialog.show();
	//alert("選択された番号は"+myDialog.r1.value+"です");
	var myAns = new Array();
	myAns['ver_sel'] = myDialog.ver_sel.selection.text;
	myAns['prev_sel'] = myDialog.prev_sel.selection.text;
	if(myDialog.prev_r1.value){
		myAns['prev_toumei']  = "透明";
	}else if(myDialog.prev_r2.value){
		myAns['prev_toumei']  = "不透明";
	}
	myAns['overprint_sel'] = myDialog.overprint_sel.selection.text;
	myAns['font'] =myDialog.font.value;
	myAns['opt01'] =myDialog.opt01.value;
	myAns['opt02'] =myDialog.opt02.value;
	myAns['opt03'] =myDialog.opt03.value;
	myAns['opt04'] =myDialog.opt04.value;
	myAns['opt_sel'] = myDialog.opt_sel.selection.text;
	return myAns;
}
function getCompatibillty(myselversion){
		switch (myselversion) {
			case "Illustrator 8 EPS":
				var mycompatibility = Compatibility.ILLUSTRATOR8; break;
			case "Illustrator 9 EPS":
				var mycompatibility = Compatibility.ILLUSTRATOR9; break;
			case "Illustrator 10 EPS":
				var mycompatibility = Compatibility.ILLUSTRATOR10; break;
			case "Illustrator CS EPS":
				var mycompatibility = Compatibility.ILLUSTRATOR11; break;
			case "Illustrator CS2 EPS":
				var mycompatibility = Compatibility.ILLUSTRATOR12; break;
			case "Illustrator CS3 EPS":
				var mycompatibility = Compatibility.ILLUSTRATOR13; break;
			case "Illustrator CS4 EPS":
				var mycompatibility = Compatibility.ILLUSTRATOR14; break;
			case "Illustrator CS5 EPS":
				var mycompatibility = Compatibility.ILLUSTRATOR15; break;
		}
		return mycompatibility;
}
function getPrev(myAns){
		switch (myAns['prev_sel']) {
			case "なし":
				var myprev = EPSPreview.None; break;
			case "TIFF (白黒)":
				var myprev = EPSPreview.BWTIFF; break;
			case "TIFF (8-bit カラー)":
				if(myAns['prev_toumei']  == "透明"){
					var myprev = EPSPreview.TRANSPARENTCOLORTIFF; break;
				}else{
					var myprev = EPSPreview.COLORTIFF; break;
				}
			case "Macintosh (白黒)":
				var myprev = EPSPreview.BWMACINTOSH; break;
			case "Macintosh (8-bit カラー)":
				var myprev = EPSPreview.COLORMACINTOSH; break;
		}
		return myprev;
}
function saveFile(folderpath,myAns){
	var docObj = app.documents;
	var docuCount = docObj.length;
	for(var i=0;i<docuCount;i++){
		var filename = docObj[i].name;
		var newfilename = deleteext(filename);
		var newfilepath = folderpath+newfilename+".eps";
		saveEPSFile(docObj[i],newfilepath,myAns);
	}
	for(i=0;i<docuCount;i++){
		docObj[0].close(SaveOptions.DONOTSAVECHANGES);
	}
}

function saveEPSFile(docObj,newfilepath,myAns){
	var fileObj = new File(newfilepath);
	var saveOptions = new EPSSaveOptions();
	saveOptions.compatibility = getCompatibillty(myAns['ver_sel']);
	saveOptions.preview = getPrev(myAns);
	if(myAns['overprint_sel'] == "保持"){
		saveOptions.overprint = PDFOverprint.PRESERVEPDFOVERPRINT; //保持
	}else{
		saveOptions.overprint = PDFOverprint.DISCARDPDFOVERPRINT; //破棄
	}
	saveOptions.embedAllFonts = myAns['font'];
	saveOptions.embedLinkedFiles = myAns['opt01'];
	saveOptions.includeDocumentThumbnails = myAns['opt02'];
	saveOptions.cmykPostScript = myAns['opt03'];
	saveOptions.compatibleGradientPrinting = myAns['opt04'];
	if(myAns['opt_sel'] == "レベル 2"){
		saveOptions.postScript = EPSPostScriptLevelEnum.LEVEL2;
	}else{
		saveOptions.postScript = EPSPostScriptLevelEnum.LEVEL3;
	}
	
	docObj.saveAs(fileObj, saveOptions);
}


//フォルダ選択ダイアログ
function getfolder(){
	var folderobj = Folder.selectDialog("保存フォルダを選択してください");
	return folderobj;
}
//拡張子をトル
function deleteext(filename){
	var flg = false;
	var refilename = "";
	for(i = filename.length-1;i > -1;i--){
		myCha = filename[i];
		if(flg){
			refilename = myCha+refilename;
		}
		if(myCha == "."){
			flg = true;
		}
	}
	if(refilename == ""){
		refilename = filename;
	}
	return refilename;
}